#STat Quest Python PCA video
#trying to doe PCA on geno_table
#pos	den8	mez2	GRC13292545_A00	GRC13292546_A00	GS000016204-ASM_A3	GS000035247-ASM_A2	GS000001577-ASM_B5	GS000001807-ASM_B4	GS000003125-ASM_B5	GS000003124-ASM_B4	GS00319-DNA_A01_1100_37-ASM_B4	GS00319-DNA_C01_1100_37-ASM_B4	GS00319-DNA_G01_1100_37-ASM_B4	GS00319-DNA_G02_1100_37-ASM_B4	GS000035246-ASM_B2	a00_A00	S_BedouinB-1_J1b2b	S_Burmese-1_O3a1c2	S_Dai-2_O21a	S_Dinka-1_E2a	S_Finnish-2_I1a1b5	S_French-1_J2a1b1	S_Gambian-1_E1b1a1a1f	S_Han-2_O1a1	S_Ju_hoan_North-1_B2b1b	S_Karitiana-1_Q1a2a1a1	S_Mandenka-1_E1b1a1a1g1	S_Mbuti-1_E1b1a1a1g1	S_Papuan-2_S	S_Punjabi-1_J2a1	S_Saami-2_N1c1a1a2a	S_Sardinian-1_J1b2b	S_Thai-1_O3a2c	S_Turkish-1_R1b1a2a1a2c1g	S_Yoruba-2_E1b1a1a1f1b1

import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from sklearn import preprocessing
from sklearn.decomposition import PCA
import jupyter
import altair as alt
alt.renderers.enable('altair_viewer')

data = pd.read_csv('Petr_Allen_Stoneage_distance_transversions_only.mx',sep='\t',comment='#',header=None)
print(data)
print(data.shape)  #gives 592 sites by 36 total samples
#data = data.set_index(0)
#print(data)



scaled_data = preprocessing.scale(data.T)  #passing in the transpose of the dataframe

pca = PCA()
pca.fit(scaled_data)  #this does all the PCA math
pca_data = pca.transform(scaled_data)   #generates coordinates for a PCA graph based on loading scores and scaled data

#make a scree plot to see how much each principal component contributes
per_var = np.round(pca.explained_variance_ratio_* 100, decimals=1)
labels = ['PC' + str(x) for x in range(1,len(per_var)+1)]  #labels for scree plot. "PC1","PC2",etc, one label per principal component
#print(labels)
plt.bar(x=range(1,len(per_var)+1),height=per_var,tick_label=labels)
plt.ylabel('Percentage of Explained Variance')
plt.xlabel('Principal Component')
plt.title('Scree Plot')
plt.show()

samples = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101]
color_list =  ['b', 'r', 'g', 'darkorange', 'g', 'g', 'b', 'c', 'c', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'blueviolet', 'darkorange', 'darkorange', 'g', 'g', 'g', 'darkorange', 'g', 'blueviolet', 'g', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'blueviolet', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'g', 'g', 'blueviolet', 'blueviolet', 'blueviolet', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'blueviolet', 'blueviolet', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'blueviolet', 'blueviolet', 'blueviolet', 'darkorange', 'blueviolet', 'darkorange', 'g', 'g', 'g', 'g', 'g']
#a00_A00	den4	den8	mez2	S_BedouinB-1_J1b2b	S_Burmese-1_O3a1c2	S_Dai-2_O21a	S_Dinka-1_E2a	S_Finnish-2_I1a1b5	S_French-1_J2a1b1	S_Gambian-1_E1b1a1a1f	S_Han-2_O1a1	S_Ju_hoan_North-1_B2b1b	S_Karitiana-1_Q1a2a1a1	S_Mandenka-1_E1b1a1a1g1	S_Mbuti-1_E1b1a1a1g1	S_Papuan-2_S	S_Punjabi-1_J2a1	spy1	S_Saami-2_N1c1a1a2a	S_Sardinian-1_J1b2b	S_Thai-1_O3a2c	S_Turkish-1_R1b1a2a1a2c1g	S_Yoruba-2_E1b1a1a1f1b1	elsidron2
#samples = ['1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25']

#samples = ['1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30','31','32','33','34','35']
#pca_df = pd.DataFrame(pca_data,index=samples,columns=labels)
#pca_df = pd.DataFrame(pca_data,index=None,columns=labels)
pca_df = pd.DataFrame(pca_data)
print(pca_df)
#plt.scatter(pca_df[0],pca_df[1],c=['r','r','b','b','b','b','c','c','c','c','c','c','c','c','c','b','darkorange','g','g','blueviolet','darkorange','darkorange','blueviolet','g','c','g','blueviolet','blueviolet','g','darkorange','g','darkorange','g','g','blueviolet'])
plt.scatter(pca_df[0],pca_df[1],c= ['b', 'r', 'g', 'darkorange', 'g', 'g', 'b', 'c', 'c', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'blueviolet', 'darkorange', 'darkorange', 'g', 'g', 'g', 'darkorange', 'g', 'blueviolet', 'g', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'blueviolet', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'g', 'g', 'blueviolet', 'blueviolet', 'blueviolet', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'blueviolet', 'blueviolet', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'blueviolet', 'blueviolet', 'blueviolet', 'darkorange', 'blueviolet', 'darkorange', 'g', 'g', 'g', 'g', 'g'])
plt.title('Neanderthal Stone Age PCA Graph')

plt.xlabel('PC1 - {0}%'.format(per_var[0]))
plt.ylabel('PC2 - {0}%'.format(per_var[1]))

# handles = ['Neander','A','B','Ham','Shem','Japheth']
# labels = ['r','b','c','blueviolet','g','gold']
# plt.legend(handles,labels)


# for s in pca_df.index:
# 	plt.annotate(s,(pca_df[0].loc[s],pca_df[1].loc[s]))

plt.annotate('Mez2',color='r',xy=(25,-6.5),fontweight='bold')
plt.annotate('A',color='b',xy=(31,-5.1),fontweight='bold')
plt.annotate('B',color='c',xy=(27,-4.8),fontweight='bold')
plt.annotate('E-H',color='blueviolet',xy=(.4,-5.3),fontweight='bold')
plt.annotate('N,O,Q,R,S',color='g',xy=(.5,4),fontweight='bold')
plt.annotate('I,J',color='darkorange',xy=(-1,-6.2),fontweight='bold')
#plt.legend()	
plt.show()



########Below are to make graph of PC2 and PC3
#samples = ['den8','mez2','GRC13292545_A00','GRC13292546_A00','GS000016204-ASM_A3','GS000035247-ASM_A2','GS000001577-ASM_B5','GS000001807-ASM_B4','GS000003125-ASM_B5','GS000003124-ASM_B4','GS00319-DNA_A01_1100_37-ASM_B4','GS00319-DNA_C01_1100_37-ASM_B4','GS00319-DNA_G01_1100_37-ASM_B4','GS00319-DNA_G02_1100_37-ASM_B4','GS000035246-ASM_B2','a00_A00','S_BedouinB-1_J1b2b','S_Burmese-1_O3a1c2','S_Dai-2_O21a','S_Dinka-1_E2a','S_Finnish-2_I1a1b5','S_French-1_J2a1b1','S_Gambian-1_E1b1a1a1f','S_Han-2_O1a1','S_Ju_hoan_North-1_B2b1b','S_Karitiana-1_Q1a2a1a1','S_Mandenka-1_E1b1a1a1g1','S_Mbuti-1_E1b1a1a1g1','S_Papuan-2_S','S_Punjabi-1_J2a1','S_Saami-2_N1c1a1a2a','S_Sardinian-1_J1b2b','S_Thai-1_O3a2c','S_Turkish-1_R1b1a2a1a2c1g','S_Yoruba-2_E1b1a1a1f1b1']
#samples = ['1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30','31','32','33','34','35']
#pca_df = pd.DataFrame(pca_data,index=samples,columns=labels)
#pca_df = pd.DataFrame(pca_data,index=None,columns=labels)
pca_df = pd.DataFrame(pca_data)
print(pca_df)
plt.scatter(pca_df[1],pca_df[2],c= ['b', 'r', 'g', 'darkorange', 'g', 'g', 'b', 'c', 'c', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'darkorange', 'blueviolet', 'darkorange', 'darkorange', 'g', 'g', 'g', 'darkorange', 'g', 'blueviolet', 'g', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'blueviolet', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'g', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'g', 'g', 'blueviolet', 'blueviolet', 'blueviolet', 'g', 'g', 'g', 'darkorange', 'g', 'g', 'blueviolet', 'blueviolet', 'darkorange', 'darkorange', 'darkorange', 'g', 'darkorange', 'darkorange', 'blueviolet', 'blueviolet', 'blueviolet', 'darkorange', 'blueviolet', 'darkorange', 'g', 'g', 'g', 'g', 'g'])
plt.title('Neanderthal Stone Age PCA Graph')

plt.xlabel('PC2 - {0}%'.format(per_var[1]))
plt.ylabel('PC3 - {0}%'.format(per_var[2]))

# plt.annotate('Ancients',color='r',xy=(-1.5,-1.3),fontweight='bold')
# plt.annotate('A',color='b',xy=(-.9,-.6),fontweight='bold')
# plt.annotate('B',color='c',xy=(-1.6,1.2),fontweight='bold')
# plt.annotate('E',color='blueviolet',xy=(3.5,2.1),fontweight='bold')
# plt.annotate('N,O,Q,R,S',color='g',xy=(.8,-1),fontweight='bold')
# plt.annotate('I,J',color='darkorange',xy=(1.2,-1.8),fontweight='bold')
plt.show()




########Below to make graph of PC1 and PC3
# pca_df = pd.DataFrame(pca_data)
# print(pca_df)
# plt.scatter(pca_df[0],pca_df[2],c=['r','r','b','b','b','b','c','c','c','c','c','c','c','c','c','b','gold','g','g','blueviolet','gold','gold','blueviolet','g','c','g','blueviolet','blueviolet','g','gold','g','gold','g','g','blueviolet'])
# plt.title('Petr Karmin_AB PCA Graph')
# 
# plt.xlabel('PC1 - {0}%'.format(per_var[0]))
# plt.ylabel('PC3 - {0}%'.format(per_var[2]))
# 
# plt.show()

alt.Chart(pca_df)
alt.Chart(pca_df).mark_point()
alt.Chart(pca_df).show()

